#!/bin/bash
# $Id: docker.SlackBuild,v 1.17 2026/03/21 12:54:21 root Exp root $
# Copyright 2014-2015 Vincent Batts <vbatts@hashbangbash.com>
# Copyright 2017-2021 Audrius Kazukauskas <audrius@neutrino.lt>
# Copyright 2022, 2023, 2024, 2025, 2026  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:          Eric Hameleers <alien@slackware.com>
# For:         docker
# Descr:       manager for applications in Linux containers
# URL:         https://www.docker.com/
# Build needs: go-md2man, google-go-lang >= 1.25
# Needs:       containerd, runc
# Changelog:   
# 20.10.12-1:  06/jan/2022 by Eric Hameleers <alien@slackware.com>
#              * Initial build.
#                This package combines docker daemon, docker init, docker proxy,
#                docker commandline client, and the buildx plugin for the cli.
# 20.10.12-2:  07/jan/2022 by Eric Hameleers <alien@slackware.com>
#              * Added the man pages.
# 20.10.16-1:  19/may/2022 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 20.10.18-1:  12/oct/2022 by Eric Hameleers <alien@slackware.com>
#              * Update. Added docker-scan.
# 24.0.2-1:    03/jul/2023 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 27.0.3-1:    11/jul/2024 by Eric Hameleers <alien@slackware.com>
#              * Update. Remove docker-scan, it has been replaced
#                by docker-scout
# 28.1.1-1:    07/may/2025 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 29.3.0-1:    21/mar/2026 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 
# Run 'sh docker.SlackBuild' to build a Slackware package.
# The package (.t?z) and .txt file as well as build logs are created in /tmp .
# Install the package using 'installpkg' or 'upgradepkg --install-new'.
#
# -----------------------------------------------------------------------------

PRGNAM=docker
VERSION=${VERSION:-29.3.0}
BUILD=${BUILD:-1}
NUMJOBS=${NUMJOBS:-" -j$(nproc) "}
TAG=${TAG:-alien}

# Additional software bundled into the docker package (following Arch Linux):
BUILDX=${BUILDX:-0.32.1}
CLI=${CLI:-29.3.0}
TINI=${TINI:-0.19.0}

# Git commit hashes we need to provide - check the 'tags' page of the
# respective github pages for these and use the hash which belongs to the tag:
BUILDX_COMMIT=d3bfb3f  # version 0.32.1 commit hash
MOBY_COMMIT=83bca51    # version 29.3.0 commit hash
TINI_COMMIT=de40ad0    # version 0.19.0 commit hash

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

DOCS="$SRCDIR/README.Slackware *.md AUTHORS Dockerfile* LICENSE MAINTAINERS NOTICE"
DOCS_BUILDX="AUTHORS Dockerfile LICENSE MAINTAINERS README.md"
DOCS_CLI="*.md AUTHORS Dockerfile LICENSE MAINTAINERS NOTICE VERSION"
DOCS_TINI="*.md Dockerfile LICENSE"

# Group 'docker' (grpId=281) is also used by SBo.
DOCKER_GID=${DOCKER_GID:-281}

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

SOURCE[0]="$SRCDIR/sources/moby-docker-v${VERSION}.tar.gz"
SRCURL[0]="https://github.com/moby/moby/archive/refs/tags/docker-v${VERSION}.tar.gz"

SOURCE[1]="$SRCDIR/sources/cli-${CLI}.tar.gz"
SRCURL[1]="https://github.com/docker/cli/archive/v${CLI}/cli-${CLI}.tar.gz"

SOURCE[2]="$SRCDIR/sources/tini-${TINI}.tar.gz"
SRCURL[2]="https://github.com/krallin/tini/archive/v${TINI}/tini-${TINI}.tar.gz"

SOURCE[3]="$SRCDIR/sources/buildx-${BUILDX}.tar.gz"
SRCURL[3]="https://github.com/docker/buildx/archive/v${BUILDX}/buildx-${BUILDX}.tar.gz"

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Automatically determine the architecture we're building on:
if [ -z "$ARCH" ]; then
  case "$(uname -m)" in
    i?86) ARCH=i586 ;;
    arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
    # Unless $ARCH is already set, use uname -m for all other archs:
    *) ARCH=$(uname -m) ;;
  esac
  export ARCH
fi
# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
case "$ARCH" in
  i?86)      SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  x86_64)    SLKCFLAGS="-O2 -fPIC"
             SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
             ;;
  armv7hl)   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  *)         SLKCFLAGS=${SLKCFLAGS:-"-O2"}
             SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
             ;;
esac

case "$ARCH" in
    arm*)    TARGET=$ARCH-slackware-linux-gnueabi ;;
    *)       TARGET=$ARCH-slackware-linux ;;
esac

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{configure,make,install,error,makepkg,patch}-${PRGNAM}*.log
                          # remove old log files

# Source file availability:
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
  if ! [ -f ${SOURCE[$i]} ]; then
    echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
    # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
    [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
    if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
    if ! [ "x${SRCURL[$i]}" == "x" ]; then
      echo "Will download file to $(dirname $SOURCE[$i])"
      wget --no-check-certificate -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
      if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
        echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
        mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
        exit 1
      fi
    fi
    if [ ! -f "${SOURCE[$i]}" -o ! -s "${SOURCE[$i]}" ]; then
      echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
      exit 1
    fi
  fi
done

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
  tar -xvf ${SOURCE[$i]}
done

chown -R root:root *
chmod -R u+w,go+r-w,a+rX-st *

echo Building ...

export GOPATH="$TMP/tmp-$PRGNAM"
export PATH="$GOPATH/bin:$PATH"
export CGO_CFLAGS="${SLKCFLAGS}"
export CGO_CXXFLAGS="${SLKCFLAGS}"
export CGO_LDFLAGS="${SLKLDFLAGS}"
export LDFLAGS=''
export GOFLAGS='-trimpath -mod=readonly -modcacherw -ldflags=-linkmode=external -ldflags=-compressdwarf=false -ldflags=-B=gobuildid'
if [ "${ARCH}" = "x86_64" ]; then
  export GOFLAGS="-buildmode=pie ${GOFLAGS}"
fi
export GO111MODULE=off
export DISABLE_WARN_OUTSIDE_CONTAINER=1

# Compile docker-cli:
echo "-- docker-cli"
# Fix the libdir on 64bit Slackware:
sed -i cli-$VERSION/cli-plugins/manager/manager_unix.go \
  -e "s,lib/,lib${LIBDIRSUFFIX}/,g"
rm -rf $GOPATH/src
mkdir -p $GOPATH/src/github.com/docker/
ln -rs cli-$CLI $GOPATH/src/github.com/docker/cli
cd $GOPATH/src/github.com/docker/cli
  make VERSION=$CLI dynbinary \
    2>&1 | tee $OUTPUT/make-${PRGNAM}_cli.log
  make manpages \
    2>&1 | tee $OUTPUT/make-${PRGNAM}_cli_man.log

cd - 1>/dev/null

# Compile docker daemon and proxy:
echo "-- docker daemon and proxy"
rm -rf $GOPATH/src
mkdir -p $GOPATH/src/github.com/moby/moby
ln -rs moby-docker-v$VERSION $GOPATH/src/github.com/moby/moby/v2
cd $GOPATH/src/github.com/moby/moby/v2
  DOCKER_GITCOMMIT=${MOBY_COMMIT} \
  DOCKER_BUILDTAGS="seccomp" \
  VERSION=$VERSION \
    hack/make.sh dynbinary \
      2>&1 | tee $OUTPUT/make-${PRGNAM}_moby.log
cd - 1>/dev/null

# Compile docker-init:
echo "-- docker-init"
rm -rf $GOPATH/src
mkdir -p $GOPATH/src/github.com/krallin/
ln -rs tini-$TINI $GOPATH/src/github.com/krallin/tini
cd $GOPATH/src/github.com/krallin/tini
  cmake . \
    -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
    2>&1 | tee $OUTPUT/configure-${PRGNAM}_tini.log
  # docker-init must be a static binary: it cannot depend on the host OS:
  make tini-static \
    2>&1 | tee $OUTPUT/make-${PRGNAM}_tini.log
cd - 1>/dev/null

# Compile buildx cli plugin:
echo "-- buildx cli plugin"
rm -rf $GOPATH/src
mkdir -p $GOPATH/src/github.com/docker/
ln -rs buildx-$BUILDX $GOPATH/src/github.com/docker/buildx
cd $GOPATH/src/github.com/docker/buildx
  GO111MODULE=on go build -mod=vendor -o docker-buildx \
    -ldflags "-linkmode=external \
    -X github.com/docker/buildx/version.Version=${BUILDX}-docker \
    -X github.com/docker/buildx/version.Revision=${BUILDX_COMMIT} \
    -X github.com/docker/buildx/version.Package=github.com/docker/buildx" \
    ./cmd/buildx \
      2>&1 | tee $OUTPUT/make-${PRGNAM}_buildx.log
cd - 1>/dev/null

# Now install the lot:
# docker-init
install -D -m0755 tini-$TINI/tini-static $PKG/usr/bin/docker-init
# dockerd:
install -D -m0755 moby-docker-v$VERSION/bundles/dynbinary-daemon/dockerd $PKG/usr/bin/dockerd
# docker-proxy:
install -D -m0755 moby-docker-v$VERSION/bundles/dynbinary-daemon/docker-proxy $PKG/usr/bin/docker-proxy
# docker-cli:
install -D -m0755 cli-$CLI/build/docker $PKG/usr/bin/docker
# Shell completions:
mkdir -p $PKG/usr/share/bash-completion/completions
cli-$CLI/build/docker completion bash \
  > $PKG/usr/share/bash-completion/completions/docker
mkdir -p $PKG/usr/share/zsh/site-functions
cli-$CLI/build/docker completion zsh \
  > $PKG/usr/share/zsh/site-functions/_docker
mkdir -p $PKG/usr/share/fish/vendor_completions.d
cli-$CLI/build/docker completion fish \
  > $PKG/usr/share/fish/vendor_completions.d/docker.fish
# Man pages:
mkdir -p $PKG/usr/man
cp -r cli-$CLI/man/man* $PKG/usr/man/
# buildx plugin:
install -D -m0755 buildx-$BUILDX/docker-buildx \
  $PKG/usr/lib${LIBDIRSUFFIX}/docker/cli-plugins/docker-buildx
# Install a symlink to the binary in the $PATH:
mkdir -p $PKG/usr/bin/
ln -s /usr/lib${LIBDIRSUFFIX}/docker/cli-plugins/docker-buildx \
  $PKG/usr/bin/docker-buildx

# Install Slackware files, ensuring that user modifications are not overwritten:
install -D -m0644 $SRCDIR/config/docker.default $PKG/etc/default/docker.new
install -D -m0644 $SRCDIR/config/docker.logrotate $PKG/etc/logrotate.d/docker.new
install -D -m0644 $SRCDIR/config/rc.docker $PKG/etc/rc.d/rc.docker.new

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION/{buildx,cli,libnetwork,tini}
( cd moby-docker-v$VERSION ; cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION )
( cd buildx-$BUILDX ; cp -a $DOCS_BUILDX $PKG/usr/doc/$PRGNAM-$VERSION/buildx )
( cd cli-$CLI ; cp -a $DOCS_CLI $PKG/usr/doc/$PRGNAM-$VERSION/cli )
( cd tini-$TINI ; cp -a $DOCS_TINI $PKG/usr/doc/$PRGNAM-$VERSION/tini )
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Compress the man page(s):
if [ -d $PKG/usr/man ]; then
  find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
  for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
fi

# Strip binaries (if any):
find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
  | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

# Add package metadata:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
cat $SRCDIR/slack-required > $PKG/install/slack-required
cat $SRCDIR/doinst.sh > $PKG/install/doinst.sh

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep

# Restore the original umask:
umask ${_UMASK_}

